﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WindowsFormsApplication1
{
    public partial class AddFCatINIC : UserControl
    {
        FCatEntryList _factEntryList = new FCatEntryList();
        public AddFCatINIC()
        {
            InitializeComponent();
            _factEntryList.FCatEntryRemoved += new EventHandler<FCatEntryEventArgs>(factEntryList_Removed);
            _factEntryList.FCatEntryAdded += new EventHandler<FCatEntryEventArgs>(factEntryList_Added);
        }

        private void factEntryList_Removed(object sender, FCatEntryEventArgs e)
        {
            foreach (Control ctrl in Controls)
            {
                FCatEntryINICControl fcatEntryCtrl = ctrl as FCatEntryINICControl;
                if (fcatEntryCtrl != null)
                {
                    if (fcatEntryCtrl.FCatEntry == e.FCatEntry)
                    {
                        Controls.Remove(ctrl);
                        break;
                    }
                }
            }
        }

        private void factEntryList_Added(object sender, FCatEntryEventArgs e)
        {
            FCatEntryINICControl newControl = new FCatEntryINICControl(e.FCatEntry, _factEntryList);
            newControl.Dock = DockStyle.Top;
            Controls.Add(newControl);
        }

        private void btnAddFCatINIC_Click(object sender, EventArgs e)
        {
            try
            {
                // var fcatEntry = _factEntryList.AddNew("Alias1", "Path1");
                var fcatEntry2 = _factEntryList.AddNew();

                fcatEntry2.Alias = "Alias2";
                fcatEntry2.Path = "Path2";

            }
            catch (Exception ex)
            {
                MessageBox.Show("Not Able To add a new Control" + ex.ToString());
            }
        }
    }
}
