﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WindowsFormsApplication1
{
    public partial class FCatEntryINICControl : UserControl
    {
        OpenFileDialog ofd = new OpenFileDialog();
        string pathname = "";

        private FCatEntry _fcatEntry;
        public FCatEntry FCatEntry { get { return _fcatEntry; } }

        private FCatEntryList _factEntryList;
        public FCatEntryINICControl()
        {
            InitializeComponent();
        }

        public FCatEntryINICControl(FCatEntry fcatEntry, FCatEntryList fcatEntryList): this()
        {
            _fcatEntry = fcatEntry;
            _factEntryList = fcatEntryList;
            rtbAliasName.Text = _fcatEntry.Alias;
            rtbPathName.Text = _fcatEntry.Path;

            // TODO: _factEntry.AliasChanged += ...
            // TODO: _factEntry.PathChanged += ...
        }

        ~FCatEntryINICControl()
        {
            // TODO: -=
        }

        private void btnSelectFile_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {

                pathname = openFileDialog1.FileName;

                //path = System.IO.Path.GetDirectoryName(ofd.FileName);

                //textBox2.Clear();
                rtbPathName.Clear();
                rtbPathName.AppendText(pathname);
                //write.IniWriteValue("Parameters", "Fcat_MOST_Pathname", pathname);
            }
        }

        private void btnDelete_Click(object sender, EventArgs e)
        {
            try
            {
                _factEntryList.Delete(_fcatEntry);
            }
            catch (Exception ex)
            {
                MessageBox.Show("Deleting not possible" + ex.ToString());
            }
        }

        private void rtbAliasName_Leave(object sender, EventArgs e)
        {
            _fcatEntry.Alias = rtbAliasName.Text;
        }

        private void rtbPathName_Leave(object sender, EventArgs e)
        {
            _fcatEntry.Path = rtbPathName.Text;
        }
    }
}
