﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace WindowsFormsApplication1
{
    public class FCatEntryList : IEnumerable<FCatEntry>
    {
        private List<FCatEntry> _innerList = new List<FCatEntry>();

        public FCatEntry AddNew()
        {
            FCatEntry result = new FCatEntry();
            _innerList.Add(result);

            OnFCatEntryAdded(result);

            return result;
        }

      /*  public FCatEntry AddNew(string alias, string path)
        {
            FCatEntry result = new FCatEntry(alias, path);
            _innerList.Add(result);

            OnFCatEntryAdded(result);

            return result;
        }*/

        protected virtual void OnFCatEntryAdded(FCatEntry fcatEntry)
        {
            EventHandler<FCatEntryEventArgs> eh = FCatEntryAdded;
            if (eh != null)
            {
                eh(this, new FCatEntryEventArgs(fcatEntry));
            }
        }

        public void Delete(FCatEntry fcatEntry)
        {
            _innerList.Remove(fcatEntry);

            EventHandler<FCatEntryEventArgs> eh = FCatEntryRemoved;
            if (eh != null)
            {
                eh(this, new FCatEntryEventArgs(fcatEntry));
            }
        }

        public int Count
        {
            get
            {
                return _innerList.Count;
            }
        }

        public FCatEntry this[int index]
        {
            get
            {
                return _innerList[index];
            }
        }

        public EventHandler<FCatEntryEventArgs> FCatEntryAdded;
        public EventHandler<FCatEntryEventArgs> FCatEntryRemoved;

        #region IEnumerable<FCatEntry> Member

        IEnumerator<FCatEntry> IEnumerable<FCatEntry>.GetEnumerator()
        {
            return _innerList.GetEnumerator();
        }

        #endregion

        #region IEnumerable Member

        System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
        {
            return (_innerList as System.Collections.IList).GetEnumerator();
        }

        #endregion
    }
}
